﻿; OpenCV + Tesseract
; How to get confidence

IncludeFile "includes/cv_functions.pbi"
IncludeFile "includes/tesseract.pbi"

Global IteratorLevel.l=0
Global  *hAPI, *image.IplImage, *imgcopy.IplImage, exitCV.b, lpPrevWndFunc

#CV_WINDOW_NAME = "OpenCV + Tesseract OCR"
#CV_DESCRIPTION = "Confidence of OCR" + Chr(10) + 
                  "- SPACEBAR: Switch between page iterator level." 

ProcedureC WindowCallback(hWnd, Msg, wParam, lParam)
  If Msg = #WM_DESTROY
      exitCV = #True
  EndIf
  ProcedureReturn CallWindowProc_(lpPrevWndFunc, hWnd, Msg, wParam, lParam)
EndProcedure

ProcedureC GetConfidence(ILevel)
  Protected *gray.IplImage, *bin.IplImage, *boxes.BOXA, *box.box
  
  cvReleaseImage(@*imagecopy)
  *imgcopy = cvCloneImage(*image)
  *gray = cvCreateImage(*imgcopy\width, *imgcopy\height, #IPL_DEPTH_8U, 1)
  *bin = cvCreateImage(*imgcopy\width, *imgcopy\height, #IPL_DEPTH_8U, 1)
  If *imgcopy\nChannels = 3
    cvCvtColor(*imgcopy, *gray, #CV_BGR2GRAY, 1)
  Else
    *gray = cvCloneImage(*imgcopy)
  EndIf  
  threshold.d = cvThreshold(*gray, *bin, 10, 255, #CV_THRESH_OTSU)    
  TessBaseAPISetImage(*hApi, *bin\imageData, *bin\width, *bin\height, 1, *bin\widthStep)
  *boxes = TessBaseAPIGetComponentImages(*hAPI, ILevel, 1, #Null, #Null)
  For i = 0 To *boxes\n - 1
    *box = boxaGetBox(*boxes, i, #L_CLONE); 
    TessBaseAPISetRectangle(*hAPI, *box\x, *box\y, *box\w, *box\h)
    ocrResult$ = RTrim(PeekS(TessBaseAPIGetUTF8Text(*hAPI), -1, #PB_UTF8),Chr(10))
    conf.f = TessBaseAPIMeanTextConf(*hAPI)
    
    Debug ocrResult$ + " : CONFIDENCE=" + Str(conf)
    
    Select conf
      Case 0 To 64
        cvRectangleR(*imgcopy, *box\x - 1, *box\y - 1, *box\w + 2, *box\h + 2, 0, 0, 255, 0, 1, #CV_AA, #Null)
      Case 65 To 77
        cvRectangleR(*imgcopy, *box\x - 1, *box\y - 1, *box\w + 2, *box\h + 2, 0, 255, 255, 0, 1, #CV_AA, #Null)
      Case 78 To 100
        cvRectangleR(*imgcopy, *box\x - 1, *box\y - 1, *box\w + 2, *box\h + 2, 0, 255, 0, 0, 1, #CV_AA, #Null)
      Default
        cvRectangleR(*imgcopy, *box\x - 1, *box\y - 1, *box\w + 2, *box\h + 2, 255, 0, 0, 0, 1, #CV_AA, #Null)
    EndSelect  
  Next  
  cvReleaseImage(@*gray)
  cvReleaseImage(@*bin)   
EndProcedure


ImageFile.s = OpenFileRequester("Choose an image file", "", "All Images (*.*)|*.bmp;*.dib;*.jpeg;*.jpg;*.jpe;*.png;*.tiff;*.tif", position)
*image.IplImage = cvLoadImage(ImageFile, #CV_LOAD_IMAGE_ANYDEPTH | #CV_LOAD_IMAGE_ANYCOLOR)  

*hAPI = TesseractInit(#PSM_AUTO, #OEM_TESSERACT_ONLY, GetPathPart(ProgramFilename())+"tessdata", "eng", "")
GetConfidence(IteratorLevel)

cvNamedWindow(#CV_WINDOW_NAME, #CV_WINDOW_AUTOSIZE)
window_handle = cvGetWindowHandle(#CV_WINDOW_NAME)
*window_name = cvGetWindowName(window_handle)
lpPrevWndFunc = SetWindowLongPtr_(window_handle, #GWL_WNDPROC, @WindowCallback())
hWnd = GetParent_(window_handle)
opencv = LoadImage_(GetModuleHandle_(0), @"icons/opencv.ico", #IMAGE_ICON, 35, 32, #LR_LOADFROMFILE)
SendMessage_(hWnd, #WM_SETICON, 0, opencv)
wStyle = GetWindowLongPtr_(hWnd, #GWL_STYLE)
SetWindowLongPtr_(hWnd, #GWL_STYLE, wStyle & ~(#WS_MAXIMIZEBOX | #WS_MINIMIZEBOX | #WS_SIZEBOX))	
cvMoveWindow(#CV_WINDOW_NAME, 20, 20)
ToolTip(window_handle, #CV_DESCRIPTION)

cvShowImage(#CV_WINDOW_NAME, *imgcopy)
Repeat  
  keyPressed = cvWaitKey(10)  
  
  If  keyPressed = 32 
    IteratorLevel + 1
    If IteratorLevel > #RIL_SYMBOL
      IteratorLevel = #RIL_BLOCK
    EndIf
    GetConfidence(IteratorLevel)
    cvShowImage(#CV_WINDOW_NAME, *imgcopy)
  EndIf      
          
Until keyPressed = 27 Or exitCV

cvReleaseImage(@*image)
cvReleaseImage(@*imagecopy)
If *hAPI
	TessBaseAPIEnd(*hAPI)
EndIf	

End
; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; CursorPosition = 98
; FirstLine = 46
; Folding = +
; EnableUnicode
; EnableXP
; CPU = 1
; CurrentDirectory = binaries\
; CompileSourceDirectory
; EnableBuildCount = 18
; EnableExeConstant